routes/web.php
<?php

/*
|--------------------------------------------------------------------------
| Web Routes
|--------------------------------------------------------------------------
|
| Here is where you can register web routes for your application. These
| routes are loaded by the RouteServiceProvider within a group which
| contains the "web" middleware group. Now create something great!
|
*/

Route::get('/', function () {
    return redirect()->route('login');
});

Auth::routes();

Route::get('/home', 'HomeController@index')->name('home');

Route::get('/charts', 'ReportController@charts')->name('charts');
Route::get('/statement', 'ReportController@statement')->name('statement');

Route::post('/charts', 'ReportController@sumChartsByPeriod')->name('post.charts');
Route::post('/statement', 'ReportController@getStatementByPeriod')->name('post.statement');

Route::resource('categories', 'CategoryController', ['except' => ['show']]);
Route::resource('bill_receives', 'BillReceiveController', ['except' => ['show']]);
Route::resource('bill_pays', 'BillPayController', ['except' => ['show']]);

Route::resource('users', 'UsersController', ['except' => ['show']]);

app/BillPay.php
<?php

namespace App;

use Illuminate\Database\Eloquent\Model;

class BillPay extends Model
{
	protected $fillable = ['date_launch','name','value','category_id'];

    public function category()
    {
    	return $this->belongsTo('App\Category');
    }
}

app/Http/Controllers/Api/v1/BillPayController.php
<?php

namespace App\Http\Controllers\Api\V1;

use App\Http\Controllers\Controller;
use Illuminate\Http\Request;
use App\User;

class BillPayController extends Controller
{
	private $model;

	/**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct(User $model)
    {
        $this->model = $model;
    }

    public function index(Request $request)
    {
        $user = $this->model->where('id', $request->user()->id)->first();

		if (!$user) {
			return response()->json(['status' => 'error', 'message' => 'Opss. Usuário não foi encontrado, favor verifique se esta logado.']);
		}

		$bill_pays = $user->bill_pays()->with('category')->get();

		return response()->json(['status' => 'success', 'data' => $bill_pays]);
    }

    public function store(Request $request)
    {
        $rules = [
            'category_id' => 'required',
            'date_launch' => 'required|date',
            'name' => 'required|min:3|max:255',
            'value' => 'required|numeric'
        ];

        $validator = \Validator::make($request->all(), $rules);

        if ($validator->fails()) {
           return response()->json(['status' => 'error', 'errors' => $validator->errors()]);
        }

        $user = $this->model->where('id', $request->user()->id)->first();

        if (!$user) {
            return response()->json(['status' => 'error', 'message' => 'Opss. Usuário não foi encontrado, favor verifique se esta logado.']);
        }
        
        $user->bill_pays()->create($request->all());

        return response()->json(['status' => 'success', 'message' => 'Conta a pagar criada com sucesso']);
    }

    public function show(Request $request, $id)
    {
        if (!$id) {
           return response()->json(['status' => 'error', 'message' => 'Conta a pagar não informada']);
        }

        $user = $this->model->where('id', $request->user()->id)->first();

        if (!$user) {
            return response()->json(['status' => 'error', 'message' => 'Opss. Usuário não foi encontrado, favor verifique se esta logado.']);
        }
        
        $bill_pay = $user->bill_pays()->find($id);

        if (!$bill_pay) {
            return response()->json(['status' => 'error', 'message' => 'Opss. Conta a pagar não encontrada pra este usuário.']);
        }

        return response()->json(['status' => 'success', 'data' => $bill_pay]);
    }

    public function update(Request $request, $id)
    {
        $rules = [
            'category_id' => 'required',
            'date_launch' => 'required|date',
            'name' => 'required|min:3|max:255',
            'value' => 'required|numeric'
        ];

        $validator = \Validator::make($request->all(), $rules);

        if ($validator->fails()) {
           return response()->json(['status' => 'error', 'errors' => $validator->errors()]);
        }

        if (!$id) {
           return response()->json(['status' => 'error', 'message' => 'Conta a pagar não informada']);
        }

        $user = $this->model->where('id', $request->user()->id)->first();

        if (!$user) {
            return response()->json(['status' => 'error', 'message' => 'Opss. Usuário não foi encontrado, favor verifique se esta logado.']);
        }
        
        $bill_pay = $user->bill_pays()->find($id);

        if (!$bill_pay) {
            return response()->json(['status' => 'error', 'message' => 'Opss. Conta a pagar não encontrada pra este usuário.']);
        }

        $bill_pay->update($request->all());

        return response()->json(['status' => 'success', 'message' => 'Conta a pagar atualizada com sucesso.']);
    }

    public function destroy(Request $request, $id)
    {
        if (!$id) {
           return response()->json(['status' => 'error', 'message' => 'Conta a pagar não informada']);
        }

        $user = $this->model->where('id', $request->user()->id)->first();

        if (!$user) {
            return response()->json(['status' => 'error', 'message' => 'Opss. Usuário não foi encontrado, favor verifique se esta logado.']);
        }
        
        $bill_pay = $user->bill_pays()->find($id);

        if (!$bill_pay) {
            return response()->json(['status' => 'error', 'message' => 'Opss. Conta a pagar não encontrada pra este usuário.']);
        }

        $bill_pay->delete();

        return response()->json(['status' => 'success', 'message' => 'Conta a pagar deletada com sucesso.']);
    }
}

app/Http/Controllers/BillPayController.php
<?php

namespace App\Http\Controllers;

use App\Category;
use Illuminate\Http\Request;
use Session;

class BillPayController extends Controller
{
    /**
     * Create a new controller instance.
     *
     * @return void
     */
    public function __construct()
    {
        $this->middleware('auth');
    }
    
    /**
     * Display a listing of the resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function index()
    {
        $bill_pays = auth()->user()->bill_pays()->orderBy('name', 'asc')->paginate(10);
        return view('bill_pays.index', compact('bill_pays'));
    }

    /**
     * Show the form for creating a new resource.
     *
     * @return \Illuminate\Http\Response
     */
    public function create()
    {
        $categories = auth()->user()->categories()->get();
        return view('bill_pays.create', compact('categories'));
    }

    /**
     * Store a newly created resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @return \Illuminate\Http\Response
     */
    public function store(Request $request)
    {
        $this->validate($request, [
            'category_id' => 'required',
            'date_launch' => 'required|date',
            'name' => 'required|min:3|max:255',
            'value' => 'required|numeric'
        ]);
        
        auth()->user()->bill_pays()->create($request->all());

        Session::flash('success', 'Conta a pagar criada com sucesso');

        return redirect()->route('bill_pays.index');
    }

    /**
     * Show the form for editing the specified resource.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function edit($id)
    {
        $categories = auth()->user()->categories()->get();
        $bill_pay = auth()->user()->bill_pays()->findOrFail($id);
        return view('bill_pays.edit', compact('bill_pay','categories'));
    }

    /**
     * Update the specified resource in storage.
     *
     * @param  \Illuminate\Http\Request  $request
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function update(Request $request, $id)
    {
        $this->validate($request, [
            'category_id' => 'required',
            'date_launch' => 'required|date',
            'name' => 'required|min:3|max:255',
            'value' => 'required|numeric'
        ]);

        $bill_pay = auth()->user()->bill_pays()->findOrFail($id);
        $bill_pay->update($request->all());
                
        Session::flash('success', 'Conta a pagar atualizada com sucesso');

        return redirect()->route('bill_pays.index');
    }

    /**
     * Remove the specified resource from storage.
     *
     * @param  int  $id
     * @return \Illuminate\Http\Response
     */
    public function destroy($id)
    {
        $bill_pay = auth()->user()->bill_pays()->findOrFail($id);        
        $bill_pay->delete();

        Session::flash('success', 'Conta a pagar deletada com sucesso');

        return redirect()->back();
    }
}

resources/views/bill_pays/create.blade.php
@extends('layouts.dashboard')

@section('content')
<!-- START PAGE CONTENT -->
<div class="content ">
  <!-- START JUMBOTRON -->
  <div class="jumbotron" data-pages="parallax">
    <div class="container-fluid container-fixed-lg sm-p-l-20 sm-p-r-20">
      <div class="inner">
        <!-- START BREADCRUMB -->
        <ul class="breadcrumb">
          <li>
            <p>Pages</p>
          </li>
          <li><a href="#" class="active">Contas a Pagar</a>
          </li>
        </ul>
        <!-- END BREADCRUMB -->
      </div>
    </div>
  </div>
  <!-- END JUMBOTRON -->
  <!-- START CONTAINER FLUID -->
  <div class="container-fluid container-fixed-lg">
    <!-- START PANEL -->
    <div class="panel panel-transparent">
      <div class="panel-heading">
        <div class="panel-title">Cadastro de Conta a Pagar
        </div>
        <div class="pull-right">
          <div class="col-xs-12">
            <a href="{{route('bill_pays.index')}}" class="btn btn-primary btn-cons">Contas a Pagar
            </a>
          </div>
        </div>
        <div class="clearfix"></div>
      </div>
      <div class="panel-body">
        <form id="form-bill_pay" class="p-t-15" role="form" action="{{ route('bill_pays.store') }}" method="post">
	        {{ csrf_field() }}
          <div class="row">
          <div class="col-sm-6">
            <div class="form-group form-group-default">
              <label>Categoria</label>
              <select class="full-width" data-placeholder="Selecione a Categoria" data-init-plugin="select2" name="category_id" id="category_id" required>
                <option value="">Selecione</option>
                @foreach($categories as $category)
                  <option value="{{$category->id}}">{{$category->name}}</option>
                @endforeach
              </select>
            </div>
            @if ($errors->has('category_id'))
                  <label id="position-error" class="error" for="position">{{ $errors->first('category_id') }}</label>
              @endif
          </div>
        </div>
	       <div class="row">
	        <div class="col-sm-6">
	          <div class="form-group form-group-default">
	            <label>Data de Lançamento</label>
	           <input type="date" class="form-control" name="date_launch" id="date_launch" required>
	          </div>
	          @if ($errors->has('date_launch'))
	                <label id="position-error" class="error" for="position">{{ $errors->first('date_launch') }}</label>
	            @endif
	        </div>
	      </div>
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group form-group-default">
              <label>Nome</label>
              <input type="text" name="name" id="name" placeholder="Nome" class="form-control" required>
            </div>
            @if ($errors->has('name'))
                  <label id="position-error" class="error" for="position">{{ $errors->first('name') }}</label>
              @endif
          </div>
        </div>
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group form-group-default">
              <label>Valor</label>
              <input type="text" name="value" id="value" class="form-control" placeholder="0.000,00" value="0,00" required>
            </div>
            @if ($errors->has('value'))
                  <label id="position-error" class="error" for="position">{{ $errors->first('value') }}</label>
              @endif
          </div>
        </div>
	      <button class="btn btn-primary btn-cons m-t-10" type="submit">Salvar</button>
	    </form>
      </div>
    </div>
    <!-- END PANEL -->
  </div>
  <!-- END CONTAINER FLUID -->
</div>
<!-- END PAGE CONTENT -->
@endsection

@section('scripts')
<script>
$(function()
{
  $('#form-bill_pay').validate();
});
</script>
@endsection

resources/views/bill_pays/edit.blade.php
@extends('layouts.dashboard')

@section('content')
<!-- START PAGE CONTENT -->
<div class="content ">
  <!-- START JUMBOTRON -->
  <div class="jumbotron" data-pages="parallax">
    <div class="container-fluid container-fixed-lg sm-p-l-20 sm-p-r-20">
      <div class="inner">
        <!-- START BREADCRUMB -->
        <ul class="breadcrumb">
          <li>
            <p>Pages</p>
          </li>
          <li><a href="#" class="active">Contas a Pagar</a>
          </li>
        </ul>
        <!-- END BREADCRUMB -->
      </div>
    </div>
  </div>
  <!-- END JUMBOTRON -->
  <!-- START CONTAINER FLUID -->
  <div class="container-fluid container-fixed-lg">
    <!-- START PANEL -->
    <div class="panel panel-transparent">
      <div class="panel-heading">
        <div class="panel-title">Editar Conta a Pagar
        </div>
        <div class="pull-right">
          <div class="col-xs-12">
            <a href="{{route('bill_pays.index')}}" class="btn btn-primary btn-cons">Contas a Pagar
            </a>
          </div>
        </div>
        <div class="clearfix"></div>
      </div>
      <div class="panel-body">
        <form id="form-bill_pay" class="p-t-15" role="form" action="{{ route('bill_pays.update', ['id' => $bill_pay->id]) }}" method="post">
	        {{method_field('PUT')}}
			{{ csrf_field() }}
      <div class="row">
          <div class="col-sm-6">
            <div class="form-group form-group-default">
              <label>Categoria</label>
              <select class="full-width" data-placeholder="Selecione a Categoria" data-init-plugin="select2" name="category_id" id="category_id" required>
                <option value="">Selecione</option>
                @foreach($categories as $category)
                  <option value="{{$category->id}}" {{ ($category->id === $bill_pay->category_id) ? 'selected' : '' }}>{{$category->name}}</option>
                @endforeach
              </select>
            </div>
            @if ($errors->has('category_id'))
                  <label id="position-error" class="error" for="position">{{ $errors->first('category_id') }}</label>
              @endif
          </div>
        </div>
	      <div class="row">
          <div class="col-sm-6">
            <div class="form-group form-group-default">
              <label>Data de Lançamento</label>
             <input type="date" class="form-control" name="date_launch" id="date_launch" value="{{$bill_pay->date_launch}}" required>
            </div>
            @if ($errors->has('date_launch'))
                  <label id="position-error" class="error" for="position">{{ $errors->first('date_launch') }}</label>
              @endif
          </div>
        </div>
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group form-group-default">
              <label>Nome</label>
              <input type="text" name="name" id="name" placeholder="Nome" class="form-control" value="{{$bill_pay->name}}" required>
            </div>
            @if ($errors->has('name'))
                  <label id="position-error" class="error" for="position">{{ $errors->first('name') }}</label>
              @endif
          </div>
        </div>
        <div class="row">
          <div class="col-sm-6">
            <div class="form-group form-group-default">
              <label>Valor</label>
              <input type="text" name="value" id="value" class="form-control" placeholder="0.000,00" value="{{$bill_pay->value}}" required>
            </div>
            @if ($errors->has('value'))
                  <label id="position-error" class="error" for="position">{{ $errors->first('value') }}</label>
              @endif
          </div>
        </div>
        <button class="btn btn-primary btn-cons m-t-10" type="submit">Atualizar</button>
	    </form>
      </div>
    </div>
    <!-- END PANEL -->
  </div>
  <!-- END CONTAINER FLUID -->
</div>
<!-- END PAGE CONTENT -->
@endsection

@section('scripts')
<script>
$(function()
{
  $('#form-bill_pay').validate();
})
</script>
@endsection

resources/views/bill_pays/index.blade.php
@extends('layouts.dashboard')

@section('content')
<!-- START PAGE CONTENT -->
<div class="content ">
  <!-- START JUMBOTRON -->
  <div class="jumbotron" data-pages="parallax">
    <div class="container-fluid container-fixed-lg sm-p-l-20 sm-p-r-20">
      <div class="inner">
        <!-- START BREADCRUMB -->
        <ul class="breadcrumb">
          <li>
            <p>Pages</p>
          </li>
          <li><a href="#" class="active">Contas a Pagar</a>
          </li>
        </ul>
        <!-- END BREADCRUMB -->
      </div>
    </div>
  </div>
  <!-- END JUMBOTRON -->
  <!-- START CONTAINER FLUID -->
  <div class="container-fluid container-fixed-lg">
    <!-- START PANEL -->
    <div class="panel panel-transparent">
      <div class="panel-heading">
        <div class="panel-title">A Pagar
        </div>
        <div class="pull-right">
          <div class="col-xs-12">
            <a href="{{route('bill_pays.create')}}" class="btn btn-primary btn-cons"><i class="fa fa-plus"></i> Adicionar
            </a>
          </div>
        </div>
        <div class="clearfix"></div>
      </div>
      <div class="panel-body">
        <table class="table table-hover demo-table-dynamic" id="tableWithDynamicRows">
          <thead>
            <tr>
              <th>Data Lançamento</th>
              <th>Nome</th>
              <th>Valor</th>
              <th>Categoria</th>
              <th>Editar</th>
              <th>Deletar</th>
            </tr>
          </thead>
          <tbody>
            @if($bill_pays->count() > 0)
              @foreach($bill_pays as $bill_pay)
                <tr>
                  <td class="v-align-middle">
                    <p>{{$bill_pay->date_launch}}</p>
                  </td>
                  <td class="v-align-middle">
                    <p>{{$bill_pay->name}}</p>
                  </td>
                  <td class="v-align-middle">
                    <p>{{$bill_pay->value}}</p>
                  </td>
                  <td class="v-align-middle">
                    <p>{{$bill_pay->category->name}}</p>
                  </td>
                  <td class="v-align-middle">
                    <a href="{{ route('bill_pays.edit', ['id' => $bill_pay->id]) }}" class="btn btn-success">
                      <i class="fa fa-pencil"></i>
                    </a>
                  </td>
                  <td class="v-align-middle">
                    <form action="{{ route('bill_pays.destroy', ['id' => $bill_pay->id ]) }}" method="post">
                        {{ csrf_field() }}
                        {{ method_field('DELETE') }}
                        <button class="btn btn-danger " onclick="return confirm('Confirma a exclusão da conta a receber?');"><i class="fa fa-trash-o"></i></button>
                    </form>
                  </td>
                </tr>
              @endforeach
            @endif
          </tbody>
        </table>
        {{ $bill_pays->render() }}
      </div>
    </div>
    <!-- END PANEL -->
  </div>
  <!-- END CONTAINER FLUID -->
</div>
<!-- END PAGE CONTENT -->
@endsection